package com.lightinit.hsdatashow.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StWaterReservoirExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public StWaterReservoirExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRegionIdIsNull() {
            addCriterion("region_id is null");
            return (Criteria) this;
        }

        public Criteria andRegionIdIsNotNull() {
            addCriterion("region_id is not null");
            return (Criteria) this;
        }

        public Criteria andRegionIdEqualTo(Long value) {
            addCriterion("region_id =", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotEqualTo(Long value) {
            addCriterion("region_id <>", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdGreaterThan(Long value) {
            addCriterion("region_id >", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdGreaterThanOrEqualTo(Long value) {
            addCriterion("region_id >=", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdLessThan(Long value) {
            addCriterion("region_id <", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdLessThanOrEqualTo(Long value) {
            addCriterion("region_id <=", value, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdIn(List<Long> values) {
            addCriterion("region_id in", values, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotIn(List<Long> values) {
            addCriterion("region_id not in", values, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdBetween(Long value1, Long value2) {
            addCriterion("region_id between", value1, value2, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionIdNotBetween(Long value1, Long value2) {
            addCriterion("region_id not between", value1, value2, "regionId");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIsNull() {
            addCriterion("region_code is null");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIsNotNull() {
            addCriterion("region_code is not null");
            return (Criteria) this;
        }

        public Criteria andRegionCodeEqualTo(String value) {
            addCriterion("region_code =", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotEqualTo(String value) {
            addCriterion("region_code <>", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeGreaterThan(String value) {
            addCriterion("region_code >", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeGreaterThanOrEqualTo(String value) {
            addCriterion("region_code >=", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLessThan(String value) {
            addCriterion("region_code <", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLessThanOrEqualTo(String value) {
            addCriterion("region_code <=", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeLike(String value) {
            addCriterion("region_code like", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotLike(String value) {
            addCriterion("region_code not like", value, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeIn(List<String> values) {
            addCriterion("region_code in", values, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotIn(List<String> values) {
            addCriterion("region_code not in", values, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeBetween(String value1, String value2) {
            addCriterion("region_code between", value1, value2, "regionCode");
            return (Criteria) this;
        }

        public Criteria andRegionCodeNotBetween(String value1, String value2) {
            addCriterion("region_code not between", value1, value2, "regionCode");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeIsNull() {
            addCriterion("reservoir_type is null");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeIsNotNull() {
            addCriterion("reservoir_type is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeEqualTo(String value) {
            addCriterion("reservoir_type =", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeNotEqualTo(String value) {
            addCriterion("reservoir_type <>", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeGreaterThan(String value) {
            addCriterion("reservoir_type >", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeGreaterThanOrEqualTo(String value) {
            addCriterion("reservoir_type >=", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeLessThan(String value) {
            addCriterion("reservoir_type <", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeLessThanOrEqualTo(String value) {
            addCriterion("reservoir_type <=", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeLike(String value) {
            addCriterion("reservoir_type like", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeNotLike(String value) {
            addCriterion("reservoir_type not like", value, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeIn(List<String> values) {
            addCriterion("reservoir_type in", values, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeNotIn(List<String> values) {
            addCriterion("reservoir_type not in", values, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeBetween(String value1, String value2) {
            addCriterion("reservoir_type between", value1, value2, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirTypeNotBetween(String value1, String value2) {
            addCriterion("reservoir_type not between", value1, value2, "reservoirType");
            return (Criteria) this;
        }

        public Criteria andReservoirNameIsNull() {
            addCriterion("reservoir_name is null");
            return (Criteria) this;
        }

        public Criteria andReservoirNameIsNotNull() {
            addCriterion("reservoir_name is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirNameEqualTo(String value) {
            addCriterion("reservoir_name =", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameNotEqualTo(String value) {
            addCriterion("reservoir_name <>", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameGreaterThan(String value) {
            addCriterion("reservoir_name >", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameGreaterThanOrEqualTo(String value) {
            addCriterion("reservoir_name >=", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameLessThan(String value) {
            addCriterion("reservoir_name <", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameLessThanOrEqualTo(String value) {
            addCriterion("reservoir_name <=", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameLike(String value) {
            addCriterion("reservoir_name like", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameNotLike(String value) {
            addCriterion("reservoir_name not like", value, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameIn(List<String> values) {
            addCriterion("reservoir_name in", values, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameNotIn(List<String> values) {
            addCriterion("reservoir_name not in", values, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameBetween(String value1, String value2) {
            addCriterion("reservoir_name between", value1, value2, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirNameNotBetween(String value1, String value2) {
            addCriterion("reservoir_name not between", value1, value2, "reservoirName");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeIsNull() {
            addCriterion("reservoir_code is null");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeIsNotNull() {
            addCriterion("reservoir_code is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeEqualTo(String value) {
            addCriterion("reservoir_code =", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeNotEqualTo(String value) {
            addCriterion("reservoir_code <>", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeGreaterThan(String value) {
            addCriterion("reservoir_code >", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeGreaterThanOrEqualTo(String value) {
            addCriterion("reservoir_code >=", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeLessThan(String value) {
            addCriterion("reservoir_code <", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeLessThanOrEqualTo(String value) {
            addCriterion("reservoir_code <=", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeLike(String value) {
            addCriterion("reservoir_code like", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeNotLike(String value) {
            addCriterion("reservoir_code not like", value, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeIn(List<String> values) {
            addCriterion("reservoir_code in", values, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeNotIn(List<String> values) {
            addCriterion("reservoir_code not in", values, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeBetween(String value1, String value2) {
            addCriterion("reservoir_code between", value1, value2, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirCodeNotBetween(String value1, String value2) {
            addCriterion("reservoir_code not between", value1, value2, "reservoirCode");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionIsNull() {
            addCriterion("reservoir_description is null");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionIsNotNull() {
            addCriterion("reservoir_description is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionEqualTo(String value) {
            addCriterion("reservoir_description =", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionNotEqualTo(String value) {
            addCriterion("reservoir_description <>", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionGreaterThan(String value) {
            addCriterion("reservoir_description >", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("reservoir_description >=", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionLessThan(String value) {
            addCriterion("reservoir_description <", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionLessThanOrEqualTo(String value) {
            addCriterion("reservoir_description <=", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionLike(String value) {
            addCriterion("reservoir_description like", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionNotLike(String value) {
            addCriterion("reservoir_description not like", value, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionIn(List<String> values) {
            addCriterion("reservoir_description in", values, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionNotIn(List<String> values) {
            addCriterion("reservoir_description not in", values, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionBetween(String value1, String value2) {
            addCriterion("reservoir_description between", value1, value2, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirDescriptionNotBetween(String value1, String value2) {
            addCriterion("reservoir_description not between", value1, value2, "reservoirDescription");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaIsNull() {
            addCriterion("reservoir_area is null");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaIsNotNull() {
            addCriterion("reservoir_area is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaEqualTo(BigDecimal value) {
            addCriterion("reservoir_area =", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaNotEqualTo(BigDecimal value) {
            addCriterion("reservoir_area <>", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaGreaterThan(BigDecimal value) {
            addCriterion("reservoir_area >", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_area >=", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaLessThan(BigDecimal value) {
            addCriterion("reservoir_area <", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaLessThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_area <=", value, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaIn(List<BigDecimal> values) {
            addCriterion("reservoir_area in", values, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaNotIn(List<BigDecimal> values) {
            addCriterion("reservoir_area not in", values, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_area between", value1, value2, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirAreaNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_area not between", value1, value2, "reservoirArea");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthIsNull() {
            addCriterion("reservoir_depth is null");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthIsNotNull() {
            addCriterion("reservoir_depth is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthEqualTo(BigDecimal value) {
            addCriterion("reservoir_depth =", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthNotEqualTo(BigDecimal value) {
            addCriterion("reservoir_depth <>", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthGreaterThan(BigDecimal value) {
            addCriterion("reservoir_depth >", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_depth >=", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthLessThan(BigDecimal value) {
            addCriterion("reservoir_depth <", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_depth <=", value, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthIn(List<BigDecimal> values) {
            addCriterion("reservoir_depth in", values, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthNotIn(List<BigDecimal> values) {
            addCriterion("reservoir_depth not in", values, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_depth between", value1, value2, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirDepthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_depth not between", value1, value2, "reservoirDepth");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageIsNull() {
            addCriterion("reservoir_impoundage is null");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageIsNotNull() {
            addCriterion("reservoir_impoundage is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageEqualTo(BigDecimal value) {
            addCriterion("reservoir_impoundage =", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageNotEqualTo(BigDecimal value) {
            addCriterion("reservoir_impoundage <>", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageGreaterThan(BigDecimal value) {
            addCriterion("reservoir_impoundage >", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_impoundage >=", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageLessThan(BigDecimal value) {
            addCriterion("reservoir_impoundage <", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageLessThanOrEqualTo(BigDecimal value) {
            addCriterion("reservoir_impoundage <=", value, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageIn(List<BigDecimal> values) {
            addCriterion("reservoir_impoundage in", values, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageNotIn(List<BigDecimal> values) {
            addCriterion("reservoir_impoundage not in", values, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_impoundage between", value1, value2, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirImpoundageNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("reservoir_impoundage not between", value1, value2, "reservoirImpoundage");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefIsNull() {
            addCriterion("reservoir_chief is null");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefIsNotNull() {
            addCriterion("reservoir_chief is not null");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefEqualTo(String value) {
            addCriterion("reservoir_chief =", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefNotEqualTo(String value) {
            addCriterion("reservoir_chief <>", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefGreaterThan(String value) {
            addCriterion("reservoir_chief >", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefGreaterThanOrEqualTo(String value) {
            addCriterion("reservoir_chief >=", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefLessThan(String value) {
            addCriterion("reservoir_chief <", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefLessThanOrEqualTo(String value) {
            addCriterion("reservoir_chief <=", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefLike(String value) {
            addCriterion("reservoir_chief like", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefNotLike(String value) {
            addCriterion("reservoir_chief not like", value, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefIn(List<String> values) {
            addCriterion("reservoir_chief in", values, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefNotIn(List<String> values) {
            addCriterion("reservoir_chief not in", values, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefBetween(String value1, String value2) {
            addCriterion("reservoir_chief between", value1, value2, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andReservoirChiefNotBetween(String value1, String value2) {
            addCriterion("reservoir_chief not between", value1, value2, "reservoirChief");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalIsNull() {
            addCriterion("impoundage_normal is null");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalIsNotNull() {
            addCriterion("impoundage_normal is not null");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalEqualTo(BigDecimal value) {
            addCriterion("impoundage_normal =", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalNotEqualTo(BigDecimal value) {
            addCriterion("impoundage_normal <>", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalGreaterThan(BigDecimal value) {
            addCriterion("impoundage_normal >", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundage_normal >=", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalLessThan(BigDecimal value) {
            addCriterion("impoundage_normal <", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundage_normal <=", value, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalIn(List<BigDecimal> values) {
            addCriterion("impoundage_normal in", values, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalNotIn(List<BigDecimal> values) {
            addCriterion("impoundage_normal not in", values, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundage_normal between", value1, value2, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundageNormalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundage_normal not between", value1, value2, "impoundageNormal");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningIsNull() {
            addCriterion("impoundagel_warning is null");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningIsNotNull() {
            addCriterion("impoundagel_warning is not null");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningEqualTo(BigDecimal value) {
            addCriterion("impoundagel_warning =", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningNotEqualTo(BigDecimal value) {
            addCriterion("impoundagel_warning <>", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningGreaterThan(BigDecimal value) {
            addCriterion("impoundagel_warning >", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundagel_warning >=", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningLessThan(BigDecimal value) {
            addCriterion("impoundagel_warning <", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningLessThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundagel_warning <=", value, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningIn(List<BigDecimal> values) {
            addCriterion("impoundagel_warning in", values, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningNotIn(List<BigDecimal> values) {
            addCriterion("impoundagel_warning not in", values, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundagel_warning between", value1, value2, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundagelWarningNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundagel_warning not between", value1, value2, "impoundagelWarning");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadIsNull() {
            addCriterion("impoundage_dead is null");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadIsNotNull() {
            addCriterion("impoundage_dead is not null");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadEqualTo(BigDecimal value) {
            addCriterion("impoundage_dead =", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadNotEqualTo(BigDecimal value) {
            addCriterion("impoundage_dead <>", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadGreaterThan(BigDecimal value) {
            addCriterion("impoundage_dead >", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundage_dead >=", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadLessThan(BigDecimal value) {
            addCriterion("impoundage_dead <", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadLessThanOrEqualTo(BigDecimal value) {
            addCriterion("impoundage_dead <=", value, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadIn(List<BigDecimal> values) {
            addCriterion("impoundage_dead in", values, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadNotIn(List<BigDecimal> values) {
            addCriterion("impoundage_dead not in", values, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundage_dead between", value1, value2, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andImpoundageDeadNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("impoundage_dead not between", value1, value2, "impoundageDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNull() {
            addCriterion("water_level_normal is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIsNotNull() {
            addCriterion("water_level_normal is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalEqualTo(BigDecimal value) {
            addCriterion("water_level_normal =", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <>", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThan(BigDecimal value) {
            addCriterion("water_level_normal >", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal >=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThan(BigDecimal value) {
            addCriterion("water_level_normal <", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_normal <=", value, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalIn(List<BigDecimal> values) {
            addCriterion("water_level_normal in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotIn(List<BigDecimal> values) {
            addCriterion("water_level_normal not in", values, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelNormalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_normal not between", value1, value2, "waterLevelNormal");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNull() {
            addCriterion("water_level_warning is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIsNotNull() {
            addCriterion("water_level_warning is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningEqualTo(BigDecimal value) {
            addCriterion("water_level_warning =", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <>", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThan(BigDecimal value) {
            addCriterion("water_level_warning >", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning >=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThan(BigDecimal value) {
            addCriterion("water_level_warning <", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_warning <=", value, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningIn(List<BigDecimal> values) {
            addCriterion("water_level_warning in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotIn(List<BigDecimal> values) {
            addCriterion("water_level_warning not in", values, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelWarningNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_warning not between", value1, value2, "waterLevelWarning");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNull() {
            addCriterion("water_level_dead is null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIsNotNull() {
            addCriterion("water_level_dead is not null");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadEqualTo(BigDecimal value) {
            addCriterion("water_level_dead =", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <>", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThan(BigDecimal value) {
            addCriterion("water_level_dead >", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead >=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThan(BigDecimal value) {
            addCriterion("water_level_dead <", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadLessThanOrEqualTo(BigDecimal value) {
            addCriterion("water_level_dead <=", value, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadIn(List<BigDecimal> values) {
            addCriterion("water_level_dead in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotIn(List<BigDecimal> values) {
            addCriterion("water_level_dead not in", values, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterLevelDeadNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("water_level_dead not between", value1, value2, "waterLevelDead");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNull() {
            addCriterion("water_quality is null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIsNotNull() {
            addCriterion("water_quality is not null");
            return (Criteria) this;
        }

        public Criteria andWaterQualityEqualTo(String value) {
            addCriterion("water_quality =", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotEqualTo(String value) {
            addCriterion("water_quality <>", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThan(String value) {
            addCriterion("water_quality >", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityGreaterThanOrEqualTo(String value) {
            addCriterion("water_quality >=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThan(String value) {
            addCriterion("water_quality <", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLessThanOrEqualTo(String value) {
            addCriterion("water_quality <=", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityLike(String value) {
            addCriterion("water_quality like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotLike(String value) {
            addCriterion("water_quality not like", value, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityIn(List<String> values) {
            addCriterion("water_quality in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotIn(List<String> values) {
            addCriterion("water_quality not in", values, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityBetween(String value1, String value2) {
            addCriterion("water_quality between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andWaterQualityNotBetween(String value1, String value2) {
            addCriterion("water_quality not between", value1, value2, "waterQuality");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(String value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(String value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(String value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(String value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(String value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(String value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLike(String value) {
            addCriterion("created_by like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotLike(String value) {
            addCriterion("created_by not like", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<String> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<String> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(String value1, String value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(String value1, String value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(String value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(String value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(String value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(String value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(String value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(String value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLike(String value) {
            addCriterion("deleted_by like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotLike(String value) {
            addCriterion("deleted_by not like", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<String> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<String> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(String value1, String value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(String value1, String value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}